# -*- coding: utf-8 -*-
#
# This file is part of Invenio.
# Copyright (C) 2016 CERN.
#
# Invenio is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# Invenio is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Invenio; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# In applying this license, CERN does not
# waive the privileges and immunities granted to it by virtue of its status
# as an Intergovernmental Organization or submit itself to any jurisdiction.

"""CLI tests."""

from __future__ import absolute_import, print_function

import json

from click.testing import CliRunner
import responses

from inspire_crawler.cli import crawler


@responses.activate
def test_list_spiders(script_info):
    """Test list spiders CLI."""
    expected = ['APS', 'BASE', 'CDS']

    runner = CliRunner()
    responses.add(
        responses.GET,
        'http://localhost:6800/listspiders.json?project=hepcrawl',
        body=json.dumps({'spiders': expected, 'status': 'ok'}),
        status=200
    )

    result = runner.invoke(crawler, ['list-spiders'], obj=script_info)

    assert result.exit_code == 0

    spiders = result.output.split()
    for spider in spiders:
        assert spider in expected
